
(**************************************************************************)
(*
(*                    
(*              Bitmap  .   
(*             ,      .
(*
(*             //    (TTextAlign = ( taLeft, taRight, taCenter ))
(*             property TextAlign: TTextAlign;
(*             //  
(*             property Background: TColor;
(*             //     
(*             property Foreground: TColor;
(*             //      
(*             property Shadow: TColor;
(*             //     (0123456789+' '+'_'+'-'+':'+'.')
(*             property Text: String;
(*             //    
(*             property ShowLines: Boolean;
(*
(**************************************************************************)

unit LedNumber; {   ver 2.45 }

interface

uses Windows,Messages,Kol;

type
  TLedNumber = class

  private
    Control:PControl;
    FShowLines: Boolean; //    FShadow?
    STextAlign: TTextAlign;
    FShadow,FForeground,FBackground: TColor;

    FFonColor,FSegColor,FNoSegColor: TColor;
    FDigits: Integer;
    FText: String;  //  
    FDrawBuffer : PBitmap;

//    procedure _OnClick( Sender: PObj );
    procedure UpdateDrawBuffer;

  public
    _prop_Text: String;   

    property _prop_Alignment: TTextAlign write STextAlign;
    property _prop_FonColor: TColor      write FFonColor;
    property _prop_SegColor: TColor      write FSegColor;
    property _prop_NoSegColor: TColor    write FNoSegColor;
    property _prop_ShowLines: Boolean    write FShowLines;

    function Init(FParent:PControl):PControl;
    destructor Destroy; override;

    procedure doText(_Text: String); //KolString
    //procedure doAlignment(var _Data:TData; Index : word);
    //procedure doFonColor(var _Data:TData; Index : word);
    //procedure doSegColor(var _Data:TData; Index : word);
    //procedure doNoSegColor(var _Data:TData; Index : word);
    //procedure doShowLines(var _Data:TData; Index : word);

    //procedure _var_Caption(var Data:TData; Index:word);

end;

implementation

function WndProcLedNumber(Sender: PControl; var Msg: TMsg; var Rslt: Integer ): Boolean;
var   P: TPaintstruct;
      fControl: TLedNumber;
begin
   fControl := TLedNumber(Sender.Tag);
   case msg.Message of
     WM_PAINT:
       begin
         BeginPaint(Sender.Handle,P);
         fControl.FDrawbuffer.Draw( Sender.Canvas.Handle, 0, 0 );
         EndPaint(Sender.Handle,P);
       end;
     WM_PRINTCLIENT:
       begin
         fControl.FDrawbuffer.Draw( hDC(Msg.wParam), 0, 0 );
       end;
     WM_SIZE:
       begin
         fControl.fDrawBuffer.Width := Sender.ClientWidth;
         fControl.fDrawBuffer.Height := Sender.ClientHeight;
         fControl.Updatedrawbuffer;
       end;
     else
       begin
         Result := False;
         exit;
       end;
   end;
   Result := True;
   Rslt := 0;
end;

destructor TLedNumber.Destroy;
begin
   FDrawBuffer.free;
   inherited;
end;

function TLedNumber.Init;
begin
   FText := _prop_Text;
   Control := NewPaintBox(FParent);
   Control.Tag := longint(Self);
   Control.Attachproc(WndProcLedNumber);
   FBackground := FFonColor;
   FForeground := FSegColor;
   FShadow := FNoSegColor;
   FDrawBuffer:= NewDIBBitmap(Control.Width,Control.Height,pf32bit);
   //Control.OnClick := _OnClick;
   
   Result := Control;
inherited;
end;
   
procedure TLedNumber.doText;
begin
   FText := _Text;
   UpdateDrawbuffer;
end;

{procedure TLedNumber.doAlignment;
begin
   STextAlign := TTextAlign(ToInteger(_Data)); 
   UpdateDrawbuffer;
end;

procedure TLedNumber.doFonColor;
begin
   FFonColor := ToInteger(_Data);
   FBackGround := FFonColor;
   UpdateDrawbuffer;
end;

procedure TLedNumber.doSegColor;
begin
   FSegColor := ToInteger(_Data);
   FForeGround := FSegColor;   
   UpdateDrawbuffer;
end;

procedure TLedNumber.doNoSegColor;
begin
   FNoSegColor := ToInteger(_Data);
   FShadow := FNoSegColor;   
   UpdateDrawbuffer;
end;

procedure TLedNumber.doShowLines;
begin
   FShowLines := ReadBool(_data);
   UpdateDrawbuffer;   
end;

procedure TLedNumber._OnClick;
begin
   //_hi_OnEvent(_event_OnClick);
end;

procedure THILedNumber._var_Caption;
begin
   //dtString(Data, FText);
end;}

procedure TLedNumber.UpdateDrawBuffer;
var
  i, j, k: Integer;
  wn, hn: Integer; //     
  pw, ph: Integer; //     "" 
{
  1_
 2|_|6
 3|_|5
   4
 7 - 
}
  //      Color
  procedure DrawDigitLine(Number: Integer; X,Y: Integer; Color: TColor);
  var
    i1,j1, tmp1, tmp2: Integer;
  begin
    // wn, hn
    // pw, ph
    with PCanvas(FDrawBuffer.Canvas){$ifndef F_P}^{$endif} do begin
    Pen.Color := Color;
    Brush.Color := Color;
    i1 := 0;
    j1 := 0;
    tmp1 := pw;
    tmp2 := ph;
    case Number of
     1:
       begin
         while j1 <= tmp2 do begin
           MoveTo(X+i1+1,Y+j1);
           LineTo(X+wn-i1-1,Y+j1);
           j1 := j1+1;
           i1 := i1+1;
         end;
       end;
     2:
       begin
         while i1 <= tmp1 do begin
           MoveTo(X+i1,Y+j1+1);
           LineTo(X+i1,Y+hn div 2-j1-1);
           j1 := j1+1;
           i1 := i1+1;
         end;
       end;
     3:
       begin
         while i1 <= tmp1 do begin
           MoveTo(X+i1,Y+hn div 2+j1+1);
           LineTo(X+i1,Y+hn-j1-1);
           j1 := j1+1;
           i1 := i1+1;
         end;
       end;
     4:
       begin
         while j1 <= tmp2 do begin
           MoveTo(X+i1+1,Y+hn-j1-1);
           LineTo(X+wn-i1-1,Y+hn-j1-1);
           j1 := j1+1;
           i1 := i1+1;
         end;
       end;
     5:
       begin
         while i1 <= tmp1 do begin
           MoveTo(X+wn-i1,Y+hn div 2+j1);
           LineTo(X+wn-i1,Y+hn-j1);
           j1 := j1+1;
           i1 := i1+1;
         end;
       end;
     6:
       begin
         while i1 <= tmp1 do begin
           MoveTo(X+wn-i1,Y+j1);
           LineTo(X+wn-i1,Y+hn div 2-j1);
           j1 := j1+1;
           i1 := i1+1;
         end;
       end;
     7:
       begin
         while j1 <= tmp2 do begin
           MoveTo(X+i1+1,Y+hn div 2-j1-1);
           LineTo(X+wn-i1-1,Y+hn div 2-j1-1);
           j1 := j1+1;
           i1 := i1+1;
         end;

         i1 := 0;
         j1 := 0;
         while j1 <= tmp2 do begin
           MoveTo(X+i1+1,Y+hn div 2+j1);
           LineTo(X+wn-i1-1,Y+hn div 2+j1);
           j1 := j1+1;
           i1 := i1+1;
         end;
       end;
    end;
    end;
  end;

  procedure DrawSymbol(X,Y: Integer; ch: Char; Color: TColor);
  begin
      FDrawBuffer.Canvas.Brush.Color := Color;
      FDrawBuffer.Canvas.Pen.Color := Color;
      case ch of
      ':':
        begin
          FDrawBuffer.Canvas.MoveTo(X+wn div 2-pw,Y+hn div 4-ph);
          FDrawBuffer.Canvas.LineTo(X+wn div 2-pw,Y+hn div 4+ph);

          FDrawBuffer.Canvas.LineTo(X+wn div 2+pw,Y+hn div 4-ph);

          FDrawBuffer.Canvas.LineTo(X+wn div 2-pw,Y+hn div 4-ph);
          FDrawBuffer.Canvas.FloodFill(X+wn div 2, Y+(hn-ph) div 4, Color, fsBorder);


          FDrawBuffer.Canvas.MoveTo(X+wn div 2+pw,Y+hn-hn div 4-ph);
          FDrawBuffer.Canvas.LineTo(X+wn div 2+pw,Y+hn-hn div 4+ph);

          FDrawBuffer.Canvas.LineTo(X+wn div 2-pw,Y+hn-hn div 4+ph);

          FDrawBuffer.Canvas.LineTo(X+wn div 2+pw,Y+hn-hn div 4-ph);
          FDrawBuffer.Canvas.FloodFill(X+wn div 2+pw div 2, Y+hn-(hn) div 4+ph div 2, Color, fsBorder);
        end;
       '.', ',':
        begin
          FDrawBuffer.Canvas.Rectangle(X+wn-2*pw, Y+hn-3*ph,X+wn, Y+hn-ph);
        end;
      end;
    end;

begin
   with Control{$ifndef F_P}^{$endif} do begin
    FDrawBuffer.canvas.Brush.Color:=FBackground;
    FDrawBuffer.canvas.Pen.Color:=FBackground;
    FDrawBuffer.Canvas.Rectangle(0, 0, width, height);

    (*    *)
    hn := Height;
    wn := 6*Height div 10;//Width div Digits - 3;

    (*    *)
    pw := wn div 7;
    ph := wn div 10;

    j := 0;

    FDigits := Length(FText);
    For i:=0 to Length(FText)-1 do begin
      // TextAlign = Left
      if STextAlign = taLeft then begin
        k := wn * i + j
      end
      else
      // TextAlign = Right
      if STextAlign = taRight then begin
        k := wn*i+j+(Width-(wn+3)*FDigits)
      end
      else begin
      // TextAlign = Center
        k := wn*i+j+(Width-(wn+3)*FDigits)div 2;
      end;
      if FShowLines then begin
        DrawDigitLine(1,k,0, fShadow);
        DrawDigitLine(2,k,0, fShadow);
        DrawDigitLine(3,k,0, fShadow);
        DrawDigitLine(4,k,0, fShadow);
        DrawDigitLine(5,k,0, fShadow);
        DrawDigitLine(6,k,0, fShadow);
        DrawDigitLine(7,k,0, fShadow);
      end;

      case FText[i+1] of
       '0':
         begin
           DrawDigitLine(1,k,0, FForeground);
           DrawDigitLine(2,k,0, FForeground);
           DrawDigitLine(3,k,0, FForeground);
           DrawDigitLine(4,k,0, FForeground);
           DrawDigitLine(5,k,0, FForeground);
           DrawDigitLine(6,k,0, FForeground);
         end;
       '1':
         begin
           DrawDigitLine(6,k,0, FForeground);
           DrawDigitLine(5,k,0, FForeground);
         end;
       '2':
         begin
           DrawDigitLine(1,k,0, FForeground);
           DrawDigitLine(6,k,0, FForeground);
           DrawDigitLine(7,k,0, FForeground);
           DrawDigitLine(3,k,0, FForeground);
           DrawDigitLine(4,k,0, FForeground);
         end;
       '3':
         begin
           DrawDigitLine(1,k,0, FForeground);
           DrawDigitLine(6,k,0, FForeground);
           DrawDigitLine(7,k,0, FForeground);
           DrawDigitLine(5,k,0, FForeground);
           DrawDigitLine(4,k,0, FForeground);
         end;
       '4':
         begin
           DrawDigitLine(2,k,0, FForeground);
           DrawDigitLine(7,k,0, FForeground);
           DrawDigitLine(6,k,0, FForeground);
           DrawDigitLine(5,k,0, FForeground);
         end;
       '5':
         begin
          DrawDigitLine(1,k,0, FForeground);
          DrawDigitLine(2,k,0, FForeground);
          DrawDigitLine(7,k,0, FForeground);
          DrawDigitLine(5,k,0, FForeground);
          DrawDigitLine(4,k,0, FForeground);
         end;
       '6':
         begin
           DrawDigitLine(1,k,0, FForeground);
           DrawDigitLine(2,k,0, FForeground);
           DrawDigitLine(3,k,0, FForeground);
           DrawDigitLine(4,k,0, FForeground);
           DrawDigitLine(5,k,0, FForeground);
           DrawDigitLine(7,k,0, FForeground);
         end;
       '7':
          begin
           DrawDigitLine(1,k,0, FForeground);
           DrawDigitLine(6,k,0, FForeground);
           DrawDigitLine(5,k,0, FForeground);
          end;
       '8':
         begin
           DrawDigitLine(1,k,0, FForeground);
           DrawDigitLine(2,k,0, FForeground);
           DrawDigitLine(3,k,0, FForeground);
           DrawDigitLine(4,k,0, FForeground);
           DrawDigitLine(5,k,0, FForeground);
           DrawDigitLine(6,k,0, FForeground);
           DrawDigitLine(7,k,0, FForeground);
         end;
       '9':
         begin
           DrawDigitLine(1,k,0, FForeground);
           DrawDigitLine(2,k,0, FForeground);
           DrawDigitLine(6,k,0, FForeground);
           DrawDigitLine(7,k,0, FForeground);
           DrawDigitLine(5,k,0, FForeground);
           DrawDigitLine(4,k,0, FForeground);
         end;
       ' ':
         begin
         end;
       '-':
          begin
           DrawDigitLine(7,k,0, FForeground);
          end;
       '_':
          begin
           DrawDigitLine(4,k,0, FForeground);
          end;
       ':': //   :)
         begin
           DrawSymbol(k,0,':', FForeground);
         end;
       '.', ',':
         begin
           DrawSymbol(k, 0, '.', FForeground);
         end;
      end;
      j := j+3;
    end;
    //Perform(WM_PAINT,-1,0); 
    Invalidate;
   end;
end;

end.